package com.jiuqi.util;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.math.BigInteger;
import java.util.Random;

public final class Guid implements Cloneable {
  private static final char[] HEX_CHARS = new char[] { 
      '0', '1', '2', '3', '4', '5', 
      '6', '7', '8', '9', 
      'A', 'B', 'C', 'D', 'E', 'F' };
  
  private static final char[] BASE64_CHARS = new char[] { 
      'A', 'B', 'C', 'D', 'E', 'F', 
      'G', 'H', 'I', 'J', 
      'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 
      'T', 
      'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 
      'e', 'f', 
      'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 
      'o', 'p', 'q', 'r', 's', 
      't', 'u', 'v', 'w', 'x', 
      'y', 'z', '0', '1', '2', '3', '4', '5', 
      '6', '7', 
      '8', '9', '+', '/', '=' };
  
  public static int GUID_SIZE = 32;
  
  public static String emptyGuid = "00000000000000000000000000000000";
  
  private static Random rndGuid = new Random(Math.round(Math.random() * 10000.0D));
  
  private byte[] data = new byte[16];
  
  public static String newGuid() {
    com.jiuqi.util.Guid T = new com.jiuqi.util.Guid();
    T.generate();
    return T.toString();
  }
  
  public void generate() {
    BigInteger BI2, BI1 = BigInteger.valueOf(System.currentTimeMillis());
    synchronized (rndGuid) {
      BI2 = new BigInteger(64, rndGuid);
    } 
    byte[] BA = BI1.toByteArray();
    int i;
    for (i = 0; i < 8 - BA.length; i++)
      this.data[i] = 0; 
    for (i = 0; i < BA.length; i++)
      this.data[8 - BA.length + i] = BA[i]; 
    BA = BI2.toByteArray();
    for (i = 0; i < 8 - BA.length; i++)
      this.data[8 + i] = 0; 
    for (i = 0; i < BA.length; i++) {
      if (BA.length - i <= 8)
        this.data[16 - BA.length + i] = BA[i]; 
    } 
  }
  
  public Object clone() {
    com.jiuqi.util.Guid copy = new com.jiuqi.util.Guid();
    copy.data = (byte[])this.data.clone();
    return copy;
  }
  
  public boolean equals(Object o) {
    if (o instanceof com.jiuqi.util.Guid)
      return this.data.equals(((com.jiuqi.util.Guid)o).data); 
    return false;
  }
  
  public String toString() {
    StringBuffer str = new StringBuffer(32);
    for (int i = 0; i < this.data.length; i++) {
      int code = this.data[i] >> 4 & 0xF;
      str.append(HEX_CHARS[code]);
      code = this.data[i] & 0xF;
      str.append(HEX_CHARS[code]);
    } 
    return str.toString();
  }
  
  public String tobase64() {
    StringBuffer s = new StringBuffer("0000000000000000000000");
    int p = 0;
    int i = 0;
    while (i < 15) {
      int j = this.data[i++];
      int k = j;
      j = j >>> 2 & 0x3F;
      s.setCharAt(p++, BASE64_CHARS[j]);
      j = this.data[i++];
      k = j;
      j = j >>> 4 & 0xF;
      k &= 0x3;
      k <<= 4;
      j |= k;
      s.setCharAt(p++, BASE64_CHARS[j]);
      j = this.data[i++];
      k = j;
      j = j >>> 6 & 0x3;
      k &= 0xF;
      k <<= 2;
      j |= k;
      s.setCharAt(p++, BASE64_CHARS[j]);
      k &= 0x3F;
      j = k;
      s.setCharAt(p++, BASE64_CHARS[j]);
    } 
    int b = this.data[i++];
    int t = b;
    b = b >>> 2 & 0x3F;
    s.setCharAt(p++, BASE64_CHARS[b]);
    b = 0;
    t = b;
    b = b >>> 4 & 0xF;
    t &= 0x3;
    t <<= 4;
    b |= t;
    s.setCharAt(p++, BASE64_CHARS[b]);
    return new String(s);
  }
}
